<template>
  <div>
    <div
      v-if="!isNew"
      class="row mb30"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="getValueFromPath(dataSource, 'eventData.occurredAt')"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="getValueFromPath(dataSource, 'eventData.authorTitle')"
          :readonly="true"
        />
      </div>
    </div>
    <template v-if="isNew">
      <div class="title mt0">Выберите точку, перед которой будет добавлена допточка</div>
      <ObSelect
        label="Адрес точки"
        pre-icon="pin"
        placeholder="Выберите из списка"
        :value="formData.visitPointUuid"
        :items="availablePoints"
        display-exp="address"
        @selected="onSelectPoint"
      />
    </template>
    <template v-if="getValueFromPath(formData, keys.visitPointUuid) || !isNew">
      <div
        v-if="isNew"
        class="title"
      >
        Параметры допточки
      </div>
      <div class="radio-block">
        <ObRadio
          :value-input="getValueFromPath(formData, keys.consigneeOrConsignor) || ''"
          model-value="CONSIGNOR"
          label="Погрузка"
          :readonly="!isManualPointTypeSelect"
          :disabled="!isNew"
          @change="onChangePointTypeSelect('CONSIGNOR')"
        />
        <ObRadio
          :value-input="getValueFromPath(formData, keys.consigneeOrConsignor) || ''"
          model-value="CONSIGNEE"
          label="Разгрузка"
          :readonly="!isManualPointTypeSelect"
          :disabled="!isNew"
          @change="onChangePointTypeSelect('CONSIGNEE')"
        />
      </div>
      <template v-if="isNew">
        <ObAddressInput
          :address="selectedAddress && selectedAddress.label"
          display-exp="russian_address"
          title="Адрес точки"
          placeholder="Укажите адрес"
          class="mb10"
          @input="onSetLocation"
          @on-change-address="onSetLocation"
        />
      </template>
      <template v-else>
        <ObInput
          label="Адрес допточки"
          :value="getValueFromPath(formData, 'specialParameters.newVisitPointData.addressTitle')"
          pre-icon="pin"
          :readonly="true"
        />
      </template>
    </template>
    <template v-if="selectedAddress || !isNew">
      <div class="mt10 mb30">
        <ConsignorOrConsigneeSelect
          :value="getValueFromPath(formData, keys.consigneeOrConsignorUuid)"
          :ownerUuid="order.clientUuid"
          :remote-trigger="selectedPoint"
          :address-title="dataSource.addressTitle"
          :address="selectedAddress"
          :point-type="getValueFromPath(formData, keys.consigneeOrConsignor)"
          :is-only-view="!this.isNew"
          @on-select-contractor="onSelectContractor"
        />
      </div>
      <div class="row mb30">
        <div class="col-xs-6">
          <ObDatePickerConstructor
            :value="getValueFromPath(formData, keys.slotStartAt)"
            label="Начало слота"
            :is-time="true"
            :readonly="!isNew"
            @input="onChangeField('newTimeSlot.slotStartAt', $event)"
          />
        </div>
        <div class="col-xs-6">
          <ObDatePickerConstructor
            :value="getValueFromPath(formData, keys.slotEndAt)"
            label="Окончание слота"
            :is-time="true"
            :readonly="!isNew"
            @input="onChangeField('newTimeSlot.slotEndAt', $event)"
          />
        </div>
      </div>
      <div class="row mb10">
        <div class="col-xs-6">
          <ObInput
            label="Новый тариф Клиента"
            :value="getValueFromPath(formData, keys.clientPriceWithVat)"
            type="money:2"
            sub-title="₽"
            :readonly="!isNew"
            @input="onChangeTariff({
              key: 'newClientTariff.priceWithVat',
              value: $event,
              role: 'Client'
            })"
          />
        </div>
        <div class="col-xs-6">
          <ObInput
            label="Сумма НДС"
            :value="getValueFromPath(formData, keys.clientVatPrice)"
            type="money:2"
            sub-title="₽"
            :readonly="true"
          />
        </div>
      </div>
      <div
        v-if="isNew"
        class="tariff-info"
      >
        {{ isNew ? 'Текущий' : 'Старый' }} тариф {{ oldClientTariff / 100 | currency({ dot: 2 }) }} ₽
      </div>
      <div
        v-if="suborderData.contractorUuid"
        class="row mb10 mt10"
      >
        <div class="col-xs-6">
          <ObInput
            label="Новый тариф Перевозчика"
            :value="getValueFromPath(formData, keys.carrierPriceWithVat)"
            type="money:2"
            sub-title="₽"
            :readonly="!isNew"
            @input="onChangeTariff({
              key: 'newCarrierTariff.priceWithVat',
              value: $event,
              role: 'Carrier'
            })"
          />
        </div>
        <div class="col-xs-6">
          <ObInput
            label="Сумма НДС"
            :value="getValueFromPath(formData, keys.carrierVatPrice)"
            type="money:2"
            sub-title="₽"
            :readonly="true"
          />
        </div>
      </div>
      <div
        v-if="isNew && suborderData.contractorUuid"
        class="tariff-info mb30"
      >
        {{ isNew ? 'Текущий' : 'Старый' }} тариф {{ oldCarrierTariff / 100 | currency({ dot: 2 }) }} ₽
      </div>
    </template>
    <div
      v-if="isNew || isEditMode || getValueFromPath(formData, keys.comment)"
      class="row"
    >
      <div class="col-xs-12">
        <ObTextarea
          :value="getValueFromPath(formData, keys.comment)"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField(keys.comment, $event)"
        />
      </div>
    </div>
    <template v-if="!currentFiles.length && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="currentFiles.length || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObAddressInput from 'common-components/src/obComponents/obAddressInput'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObRadio from 'common-components/src/obComponents/obRadio'
import ConsignorOrConsigneeSelect from '@/components/Order/orderItem/ConsignorOrConsigneeSelect'
import { getValueFromPath } from 'common-components/src/helpers/common'

export default {
  name: 'AddPointEventForm',
  components: {
    ObRadio,
    ObInput,
    ObSelect,
    ObTextarea,
    ObUploader,
    ObAddressInput,
    ObDatePickerConstructor,
    ConsignorOrConsigneeSelect
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
  },
  data () {
    return {
      selectedPoint: null,
      selectedAddress: null,
      suborderData: {}
    }
  },
  watch: {
    dataSource: {
      immediate: true,
      handler (dataSource) {
        const { subOrders } = dataSource
        const isOneSuborder = subOrders.length === 1
        const isTariff = isOneSuborder && subOrders[0].contractorUuid

        if (isTariff) {
          this.getSuborderData(subOrders[0])
        }

        this.selectedPoint = null
        this.selectedAddress = null
        this.suborderData = {}
      }
    },
    currentFiles (value) {
      if (!value || !value.length) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    keys () {
      return {
        visitPointUuid: this.isNew ? 'visitPointUuid' : 'specialParameters.visitPointUuid',
        consigneeOrConsignorUuid: this.isNew ? 'newVisitPointData.consigneeOrConsignorUuid' : 'specialParameters.newVisitPointData.consigneeOrConsignorUuid',
        consigneeOrConsignor: this.isNew ? 'newVisitPointData.consigneeOrConsignor' : 'specialParameters.newVisitPointData.consigneeOrConsignor',
        slotStartAt: this.isNew ? 'newTimeSlot.slotStartAt' : 'specialParameters.newTimeSlot.slotStartAt',
        slotEndAt: this.isNew ? 'newTimeSlot.slotEndAt' : 'specialParameters.newTimeSlot.slotEndAt',
        clientPriceWithVat: this.isNew ? 'newClientTariff.priceWithVat' : 'specialParameters.newClientTariff.priceWithVat',
        clientVatPrice: this.isNew ? 'newClientTariff.vatPrice' : 'specialParameters.newClientTariff.vatPrice',
        carrierPriceWithVat: this.isNew ? 'newCarrierTariff.priceWithVat' : 'specialParameters.newCarrierTariff.priceWithVat',
        carrierVatPrice: this.isNew ? 'newCarrierTariff.vatPrice' : 'specialParameters.newCarrierTariff.vatPrice',
        comment: this.isNew ? 'comment' : 'eventData.comment',
        fileUuids: this.isNew ? 'fileUuids' : 'eventData.fileUuids'
      }
    },
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource?.filesData || []
    },
    currentDirection () {
      return this.isConsignor ? 'FROM' : 'TO'
    },
    isConsignor () {
      return this.getValueFromPath(this.formData, this.keys.consigneeOrConsignor) === 'CONSIGNOR'
    },
    contractorTypeWordRoot () {
      return this.isConsignor
        ? 'рузоотправител'
        : 'рузополучател'
    },
    availablePoints () {
      const list = this.order.brif?.visitPoints || []
      const activePoints = list.filter(item => !item.hasReachedByTrip).map((item, index) => {
        return { ...item, icon: 'pin', index }
      })
      const lastElement = {
        address: 'Добавить допточку в самый конец маршрута',
        uuid: 'last',
        index: activePoints.length
      }

      return [ ...activePoints, lastElement ]
    },
    availablePointsCount () {
      return this.availablePoints.length
    },
    lastAvailablePointIndex () {
      return this.availablePointsCount ? this.availablePointsCount - 1 : null
    },
    oldClientTariff () {
      return this.order.actualTariff?.orderCost?.priceWithVat || this.order.totalPrice
    },
    oldCarrierTariff () {
      return this.suborderData.totalPrice
    },
    isManualPointTypeSelect () {
      if (!this.isNew || !this.selectedPoint) return false

      const { ordinal, type } = this.selectedPoint

      return (ordinal === 1 && type === 'TO')
    }
  },
  methods: {
    getValueFromPath (data, path) {
      return getValueFromPath({ data, path })
    },
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField(this.keys.fileUuids, null)
        return
      }

      this.onChangeField(this.keys.fileUuids, data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    onChangePointTypeSelect (value) {
      this.onChangeField('newVisitPointData.consigneeOrConsignor', value)
      this.onChangeField('newVisitPointData.consigneeOrConsignorUuid', '')
      this.onChangeField('newVisitPointData.direction', value === 'CONSIGNOR' ? 'FROM' : 'TO')
    },
    async getSuborderData (data) {
      this.suborderData = await api.orderProcess.getSubOrder({
        data,
        orderUuid: this.order.uuid,
        isClient: false
      })
    },
    onSelectContractor (item) {
      this.onChangeField('newVisitPointData.consigneeOrConsignorUuid', item.uuid)
    },
    getPointTypeBySelectedPoint ({ index, ordinal, type } = {}) {
      if ((ordinal === 1 && type === 'TO') || index === this.lastAvailablePointIndex) return 'CONSIGNEE'

      return type === 'TO' ? 'CONSIGNEE' : 'CONSIGNOR'
    },
    onSelectPoint (point) {
      this.selectedPoint = point

      this.onChangeField('visitPointUuid', point.uuid)
      this.onChangeField('newVisitPointData.consigneeOrConsignor', this.getPointTypeBySelectedPoint(point))
      this.onChangeField('newVisitPointData.addressTitle', '')
      this.onChangeField('newVisitPointData.consigneeOrConsignorUuid', '')
      this.onChangeField('newVisitPointData.coordinates.lat', '')
      this.onChangeField('newVisitPointData.coordinates.lon', '')
      this.onChangeField('newVisitPointData.direction', '')
      this.selectedAddress = null
    },
    onSetLocation (point) {
      const { label, coordinates } = point

      this.selectedAddress = point
      this.onChangeField('newVisitPointData.addressTitle', label)
      this.onChangeField('newVisitPointData.consigneeOrConsignorUuid', '')
      this.onChangeField('newVisitPointData.coordinates.lat', coordinates.lat)
      this.onChangeField('newVisitPointData.coordinates.lon', coordinates.lon)
      this.onChangeField('newVisitPointData.direction', this.currentDirection)

      this.onChangeField('newTimeSlot.slotStartAt', this.selectedPoint.timeSlot?.startAt)
      this.onChangeField('newTimeSlot.slotEndAt', this.selectedPoint.timeSlot?.endAt)

      this.onChangeField('newClientTariff.priceWithoutVat', this.order.totalPriceWithoutVat || this.order.totalPrice)
      this.onChangeField('newClientTariff.vatPrice', this.order.vatValue)
      this.onChangeField('newClientTariff.vatRate', this.order.orderTotalAmount?.vatRate || 0)
      this.onChangeField('newClientTariff.priceWithVat', this.order.totalPrice)

      this.onChangeField('newCarrierTariff.priceWithoutVat', this.suborderData.totalPriceWithoutVat || this.suborderData.totalPrice)
      this.onChangeField('newCarrierTariff.vatPrice', this.suborderData.totalVat)
      this.onChangeField('newCarrierTariff.vatRate', this.suborderData.orderTotalAmount?.vatRate || 0)
      this.onChangeField('newCarrierTariff.priceWithVat', this.suborderData.totalPrice)
    },
    onChangeTariff ({ key, value, role }) {
      const priceWithoutVat = this.calcPriceWithoutVat(value, this.formData['new' + role + 'Tariff'].vatRate)
      const vatPrice = value - priceWithoutVat

      this.onChangeField('new' + role + 'Tariff.vatPrice', vatPrice)
      this.onChangeField('new' + role + 'Tariff.priceWithoutVat', priceWithoutVat)
      this.onChangeField(key, value)
    },
    calcPriceWithoutVat (price, vatRate) {
      return Math.round(price / ((100 + vatRate) / 100))
    },
    showConfirmModal () {
      this.$refs.confirmModal.open()
    },
    submitForm () {
      this.$refs.confirmModal.close()
      this.$emit('submit-form')
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.row-input {
  margin-right: 0;
  margin-left: 0;
  flex-wrap: nowrap;
  &__item {
    width: 212px;
    flex-grow: 2;
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
  &__counter {
    width: 135px;
  }
}

.mb10 {
  margin-bottom: 10px!important;
}

.mt10 {
  margin-top: 10px!important;
}

.mb30 {
  margin-bottom: 30px!important;
}

.mt0 {
  margin-top: 0!important;
}

.radio-block {
  display: flex;
  align-items: center;
  margin-bottom: 15px;
  &::v-deep {
    .ob-radio-container {
      & + .ob-radio-container {
        margin-left: 25px;
      }
    }
  }
}

.tariff-info {
  @include font-mixin(14px, 18px, 400, $color-grey-label);
}

.block-inn {
  margin-bottom: 30px;
  margin-top: 10px;
  span {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    &:first-child {
      margin-right: 7px;
      color: $color-grey-label;
    }
  }
}
</style>